<?php

namespace FiloBlu\Flow\Model\AmastyMultiInventory;

/**
 * Class FullFactory
 * @package FiloBlu\Flow\Model\AmastyMultiInventory
 */
class FullFactory
{
    /**
     * @var \Magento\Framework\Module\Manager
     */
    protected $moduleManager;
    /**
     * @var \Magento\Framework\ObjectManagerInterface
     */
    protected $objectManager;

    /**
     * FullFactory constructor.
     * @param \Magento\Framework\Module\Manager $moduleManager
     * @param \Magento\Framework\ObjectManagerInterface $objectManager
     */
    public function __construct(
        \Magento\Framework\Module\Manager $moduleManager,
        \Magento\Framework\ObjectManagerInterface $objectManager
    )
    {
        $this->moduleManager = $moduleManager;
        $this->objectManager = $objectManager;
    }

    /**
     * @param array $data
     * @param null $className
     * @return mixed|null
     */
    public function create(array $data = [],$className = null)
    {
        if(!$className){
            return null;
        }

        $instanceName = null;
        if ($this->moduleManager->isEnabled('Amasty_MultiInventory')) {
            $instanceName = $className;
        }

        if($instanceName){
            return $this->objectManager->create($instanceName, $data);
        } else {
            return $instanceName;
        }
    }
}
